
#ifndef _MANAGEMENT_SUBSCRIPTION_
#define _MANAGEMENT_SUBSCRIPTION_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace org {
namespace apache {
namespace qpid {
namespace broker {


class Subscription : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    ::qpid::management::ObjectId sessionRef;
    ::qpid::management::ObjectId queueRef;
    std::string name;
    uint8_t browsing;
    uint8_t acknowledged;
    uint8_t exclusive;
    std::string creditMode;
    ::qpid::framing::FieldTable arguments;

    // Statistics


    // Per-Thread Statistics
    struct PerThreadStats {
        uint64_t  delivered;

    };

    struct PerThreadStats** perThreadStatsArray;

    inline struct PerThreadStats* getThreadStats() {
        int idx = getThreadIndex();
        struct PerThreadStats* threadStats = perThreadStatsArray[idx];
        if (threadStats == 0) {
            threadStats = new(PerThreadStats);
            perThreadStatsArray[idx] = threadStats;
            threadStats->delivered = 0;

        }
        return threadStats;
    }

    void aggregatePerThreadStats(struct PerThreadStats*);

    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

  public:

    Subscription(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject, ::qpid::management::Manageable* _parent, const ::qpid::management::ObjectId& _queueRef, const std::string& _name, uint8_t _browsing, uint8_t _acknowledged, uint8_t _exclusive, const ::qpid::framing::FieldTable& _arguments);
    ~Subscription();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs

    // Accessor Methods
    inline void set_creditMode (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        creditMode = val;
        configChanged = true;
    }
    inline const std::string& get_creditMode() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return creditMode;
    }
    inline void inc_delivered (uint64_t by = 1) {
        getThreadStats()->delivered += by;
        instChanged = true;
    }
    inline void dec_delivered (uint64_t by = 1) {
        getThreadStats()->delivered -= by;
        instChanged = true;
    }

};

}}}}}

#endif  /*!_MANAGEMENT_SUBSCRIPTION_*/
