/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/ClusterConnectionAnnounceBody.h"
#include "qpid/framing/reply_exceptions.h"

using namespace qpid::framing;

void ClusterConnectionAnnounceBody::setSsf(uint32_t _ssf) {
    ssf = _ssf;
    flags |= (1 << 8);
}
uint32_t ClusterConnectionAnnounceBody::getSsf() const { return ssf; }
bool ClusterConnectionAnnounceBody::hasSsf() const { return flags & (1 << 8); }
void ClusterConnectionAnnounceBody::clearSsfFlag() { flags &= ~(1 << 8); }

void ClusterConnectionAnnounceBody::encodeStructBody(Buffer& buffer) const
{
encodeHeader(buffer);
    buffer.putShort(flags);
    if (flags & (1 << 8))
        buffer.putLong(ssf);
}

void ClusterConnectionAnnounceBody::encode(Buffer& buffer) const
{
    encodeStructBody(buffer);
}

void ClusterConnectionAnnounceBody::decodeStructBody(Buffer& buffer, uint32_t /*size*/)
{
decodeHeader(buffer);
    flags = buffer.getShort();
    if (flags & (1 << 8))
        ssf = buffer.getLong();
}

void ClusterConnectionAnnounceBody::decode(Buffer& buffer, uint32_t /*size*/)
{
    decodeStructBody(buffer);
}

uint32_t ClusterConnectionAnnounceBody::bodySize() const
{
    uint32_t total = 0;
total += headerSize();
    total += 2;
    if (flags & (1 << 8))
        total += 4;//ssf
    return total;
}

uint32_t ClusterConnectionAnnounceBody::encodedSize() const {
    uint32_t total = bodySize();
    return total;
}

void ClusterConnectionAnnounceBody::print(std::ostream& out) const
{
    out << "{ClusterConnectionAnnounceBody: ";
    if (flags & (1 << 8))
        out << "ssf=" << ssf << "; ";
    out << "}";
}
