
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/management/ManagementAgent.h"
#include "Journal.h"
#include "ArgsJournalExpand.h"


using namespace qmf::com::redhat::rhm::store;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Journal::packageName  = string ("com.redhat.rhm.store");
string  Journal::className    = string ("journal");
uint8_t Journal::md5Sum[16]   =
    {0x9,0xc2,0xe2,0xfc,0xcc,0x2e,0x72,0xaa,0x3f,0xce,0x36,0x28,0xce,0x81,0xc,0xd4};

Journal::Journal (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    queueRef = ::qpid::management::ObjectId();
    name = "";
    directory = "";
    baseFileName = "";
    writePageSize = 0;
    writePages = 0;
    readPageSize = 0;
    readPages = 0;
    initialFileCount = 0;
    autoExpand = 0;
    currentFileCount = 0;
    maxFileCount = 0;
    dataFileSize = 0;
    recordDepth = 0;
    recordDepthHigh = 0;
    recordDepthLow  = 0;
    outstandingAIOs = 0;
    outstandingAIOsHigh = 0;
    outstandingAIOsLow  = 0;
    freeFileCount = 0;
    freeFileCountHigh = 0;
    freeFileCountLow  = 0;
    availableFileCount = 0;
    availableFileCountHigh = 0;
    availableFileCountLow  = 0;
    writePageCacheDepth = 0;
    writePageCacheDepthHigh = 0;
    writePageCacheDepthLow  = 0;
    readPageCacheDepth = 0;
    readPageCacheDepthHigh = 0;
    readPageCacheDepthLow  = 0;



    perThreadStatsArray = new struct PerThreadStats*[maxThreads];
    for (int idx = 0; idx < maxThreads; idx++)
        perThreadStatsArray[idx] = 0;

}

Journal::~Journal ()
{

    for (int idx = 0; idx < maxThreads; idx++)
        if (perThreadStatsArray[idx] != 0)
            delete perThreadStatsArray[idx];
    delete[] perThreadStatsArray;

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Journal::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Journal::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (13); // Config Element Count
    buf.putShort       (29); // Inst Element Count
    buf.putShort       (1); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "queueRef");
    ft.setInt    (TYPE, TYPE_REF);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "name");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "directory");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Directory containing journal files");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "baseFileName");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Base filename prefix for journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "writePageSize");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "byte");
    ft.setString (DESC,   "Page size in write-page-cache");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "writePages");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "wpage");
    ft.setString (DESC,   "Number of pages in write-page-cache");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "readPageSize");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "byte");
    ft.setString (DESC,   "Page size in read-page-cache");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "readPages");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "rpage");
    ft.setString (DESC,   "Number of pages in read-page-cache");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "initialFileCount");
    ft.setInt    (TYPE, TYPE_U16);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "file");
    ft.setString (DESC,   "Number of files initially allocated to this journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "autoExpand");
    ft.setInt    (TYPE, TYPE_BOOL);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Auto-expand enabled");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "currentFileCount");
    ft.setInt    (TYPE, TYPE_U16);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "file");
    ft.setString (DESC,   "Number of files currently allocated to this journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "maxFileCount");
    ft.setInt    (TYPE, TYPE_U16);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "file");
    ft.setString (DESC,   "Max number of files allowed for this journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "dataFileSize");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "byte");
    ft.setString (DESC,   "Size of each journal data file");
    buf.put (ft);


    // Statistics
    ft.clear();
    ft.setString (NAME,   "recordDepth");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Number of currently enqueued records (durable messages)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "recordDepthHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Number of currently enqueued records (durable messages) (High)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "recordDepthLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Number of currently enqueued records (durable messages) (Low)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "enqueues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Total enqueued records on journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "dequeues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Total dequeued records on journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "txn");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Total open transactions (xids) on journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "txnEnqueues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Total transactional enqueued records on journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "txnDequeues");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Total transactional dequeued records on journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "txnCommits");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Total transactional commit records on journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "txnAborts");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Total transactional abort records on journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "outstandingAIOs");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "aio_op");
    ft.setString (DESC,   "Number of currently outstanding AIO requests in Async IO system");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "outstandingAIOsHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "aio_op");
    ft.setString (DESC,   "Number of currently outstanding AIO requests in Async IO system (High)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "outstandingAIOsLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "aio_op");
    ft.setString (DESC,   "Number of currently outstanding AIO requests in Async IO system (Low)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "freeFileCount");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "file");
    ft.setString (DESC,   "Number of files free on this journal. Includes free files trapped in holes.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "freeFileCountHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "file");
    ft.setString (DESC,   "Number of files free on this journal. Includes free files trapped in holes. (High)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "freeFileCountLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "file");
    ft.setString (DESC,   "Number of files free on this journal. Includes free files trapped in holes. (Low)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "availableFileCount");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "file");
    ft.setString (DESC,   "Number of files available to be written.  Excluding holes");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "availableFileCountHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "file");
    ft.setString (DESC,   "Number of files available to be written.  Excluding holes (High)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "availableFileCountLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "file");
    ft.setString (DESC,   "Number of files available to be written.  Excluding holes (Low)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "writeWaitFailures");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "AIO Wait failures on write");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "writeBusyFailures");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "AIO Busy failures on write");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "readRecordCount");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "Records read from the journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "readBusyFailures");
    ft.setInt    (TYPE,   TYPE_U64);
    ft.setString (UNIT,   "record");
    ft.setString (DESC,   "AIO Busy failures on read");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "writePageCacheDepth");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "wpage");
    ft.setString (DESC,   "Current depth of write-page-cache");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "writePageCacheDepthHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "wpage");
    ft.setString (DESC,   "Current depth of write-page-cache (High)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "writePageCacheDepthLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "wpage");
    ft.setString (DESC,   "Current depth of write-page-cache (Low)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "readPageCacheDepth");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "rpage");
    ft.setString (DESC,   "Current depth of read-page-cache");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "readPageCacheDepthHigh");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "rpage");
    ft.setString (DESC,   "Current depth of read-page-cache (High)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "readPageCacheDepthLow");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "rpage");
    ft.setString (DESC,   "Current depth of read-page-cache (Low)");
    buf.put (ft);


    // Methods
    ft.clear();
    ft.setString (NAME,     "expand");
    ft.setInt    (ARGCOUNT, 1);
    ft.setString (DESC,     "Increase number of files allocated for this journal");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "by");
    ft.setInt    (TYPE,    TYPE_U32);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "Number of files to increase journal size by");
    buf.put (ft);


}


void Journal::aggregatePerThreadStats(struct PerThreadStats* totals)
{
    totals->enqueues = 0;
    totals->dequeues = 0;
    totals->txn = 0;
    totals->txnEnqueues = 0;
    totals->txnDequeues = 0;
    totals->txnCommits = 0;
    totals->txnAborts = 0;
    totals->writeWaitFailures = 0;
    totals->writeBusyFailures = 0;
    totals->readRecordCount = 0;
    totals->readBusyFailures = 0;

    for (int idx = 0; idx < maxThreads; idx++) {
        struct PerThreadStats* threadStats = perThreadStatsArray[idx];
        if (threadStats != 0) {
            totals->enqueues += threadStats->enqueues;
            totals->dequeues += threadStats->dequeues;
            totals->txn += threadStats->txn;
            totals->txnEnqueues += threadStats->txnEnqueues;
            totals->txnDequeues += threadStats->txnDequeues;
            totals->txnCommits += threadStats->txnCommits;
            totals->txnAborts += threadStats->txnAborts;
            totals->writeWaitFailures += threadStats->writeWaitFailures;
            totals->writeBusyFailures += threadStats->writeBusyFailures;
            totals->readRecordCount += threadStats->readRecordCount;
            totals->readBusyFailures += threadStats->readBusyFailures;

        }
    }
}


void Journal::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    queueRef.encode(buf);
    buf.putShortString(name);
    buf.putShortString(directory);
    buf.putShortString(baseFileName);
    buf.putLong(writePageSize);
    buf.putLong(writePages);
    buf.putLong(readPageSize);
    buf.putLong(readPages);
    buf.putShort(initialFileCount);
    buf.putOctet(autoExpand?1:0);
    buf.putShort(currentFileCount);
    buf.putShort(maxFileCount);
    buf.putLong(dataFileSize);

}

void Journal::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;


    struct PerThreadStats totals;
    aggregatePerThreadStats(&totals);


    if (!skipHeaders)
        writeTimestamps (buf);
    buf.putLong(recordDepth);
    buf.putLong(recordDepthHigh);
    buf.putLong(recordDepthLow);
    buf.putLongLong(totals.enqueues);
    buf.putLongLong(totals.dequeues);
    buf.putLong(totals.txn);
    buf.putLongLong(totals.txnEnqueues);
    buf.putLongLong(totals.txnDequeues);
    buf.putLongLong(totals.txnCommits);
    buf.putLongLong(totals.txnAborts);
    buf.putLong(outstandingAIOs);
    buf.putLong(outstandingAIOsHigh);
    buf.putLong(outstandingAIOsLow);
    buf.putLong(freeFileCount);
    buf.putLong(freeFileCountHigh);
    buf.putLong(freeFileCountLow);
    buf.putLong(availableFileCount);
    buf.putLong(availableFileCountHigh);
    buf.putLong(availableFileCountLow);
    buf.putLongLong(totals.writeWaitFailures);
    buf.putLongLong(totals.writeBusyFailures);
    buf.putLongLong(totals.readRecordCount);
    buf.putLongLong(totals.readBusyFailures);
    buf.putLong(writePageCacheDepth);
    buf.putLong(writePageCacheDepthHigh);
    buf.putLong(writePageCacheDepthLow);
    buf.putLong(readPageCacheDepth);
    buf.putLong(readPageCacheDepthHigh);
    buf.putLong(readPageCacheDepthLow);


    // Maintenance of hi-lo statistics
    recordDepthHigh = recordDepth;
    recordDepthLow  = recordDepth;
    outstandingAIOsHigh = outstandingAIOs;
    outstandingAIOsLow  = outstandingAIOs;
    freeFileCountHigh = freeFileCount;
    freeFileCountLow  = freeFileCount;
    availableFileCountHigh = availableFileCount;
    availableFileCountLow  = availableFileCount;
    writePageCacheDepthHigh = writePageCacheDepth;
    writePageCacheDepthLow  = writePageCacheDepth;
    readPageCacheDepthHigh = readPageCacheDepth;
    readPageCacheDepthLow  = readPageCacheDepth;


}

void Journal::doMethod (string& methodName, Buffer& inBuf, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "expand") {
        ArgsJournalExpand ioArgs;
        ioArgs.i_by = inBuf.getLong();
        status = coreObject->ManagementMethod (METHOD_EXPAND, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
